unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, ExtCtrls, TeeProcs, Chart, Series, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Series1ClickPointer(Sender: TCustomSeries; ValueIndex, X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ClickSeries: TLineSeries;
  ClickPoint: integer;

implementation

{$R *.dfm}

procedure TForm1.Chart1ClickSeries(Sender: TCustomChart; Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ClickSeries = nil then
  begin
    ClickSeries := TLineSeries(Series);
    ClickPoint := ValueIndex;

    Form1.Caption := 'ClickSeries :: Index: ' + IntToStr(ClickPoint) + ' - Value = ' + FormatFloat('#,##0.0', ClickSeries.YValue[ClickPoint]);
  end;
end;

procedure TForm1.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  xValue: double;
begin
  if assigned(ClickSeries) then
  begin
    xValue := ClickSeries.YScreenToValue(y);
    ClickSeries.YValues[ClickPoint] := xValue;
    Chart1.Refresh;
    Form1.Caption := 'Move :: Index: ' + IntToStr(ClickPoint) + ' - Value = ' + FormatFloat('#,##0.0', ClickSeries.YValue[ClickPoint]);
  end;
end;

procedure TForm1.Chart1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ClickSeries := nil;
  ClickPoint := -1;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  s: TLineSeries;
  i: integer;
begin

  Chart1.LeftAxis.AutomaticMinimum := false;
  Chart1.LeftAxis.Minimum := 0;

  s := TLineSeries.Create(Chart1);
  s.ClickableLine := true;
  s.Color := clRed;
  s.Pen.Width := 3;
  s.Pointer.Style := psCircle;
  s.Pointer.Size := 5;
  s.Pointer.Brush.Color := RGB(255, 128, 128);
  s.Pointer.Pen.Color := clBlack;
  s.Pointer.Pen.Width := 1;
  s.Pointer.Brush.Color := clRed;
  s.Pointer.Visible := true;
  s.Cursor := crSizeNS;
  s.OnClickPointer := Series1ClickPointer;

  Chart1.AddSeries(s);

  for i := 0 to 10 do
  begin
    s.AddXY(i, 10);
    Series1.AddXY(i, 5);
  end;

  ClickSeries := nil;
  ClickPoint := -1;

end;

procedure TForm1.Series1ClickPointer(Sender: TCustomSeries; ValueIndex, X, Y: Integer);
begin
  if ClickSeries = nil then
  begin
    ClickSeries := TLineSeries(Sender);
    ClickPoint := ValueIndex;
    Form1.Caption := 'ClickPointer :: Index: ' + IntToStr(ClickPoint) + ' - Value = ' + FormatFloat('#,##0.0', ClickSeries.YValue[ClickPoint]);
    Beep();
  end;
end;

end.
